"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[16649],{8809:(e,i,t)=>{t.r(i),t.d(i,{assets:()=>o,contentTitle:()=>s,default:()=>u,frontMatter:()=>a,metadata:()=>l,toc:()=>d});var n=t(785893),r=t(511151);const a={title:"Blueprints"},s=void 0,l={id:"blueprints/index",title:"Blueprints",description:"Requires authentik 2022.8",source:"@site/developer-docs/blueprints/index.md",sourceDirName:"blueprints",slug:"/blueprints/",permalink:"/developer-docs/blueprints/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/developer-docs/blueprints/index.md",tags:[],version:"current",frontMatter:{title:"Blueprints"},sidebar:"docs",previous:{title:"Contributing to authentik",permalink:"/developer-docs/"},next:{title:"Export",permalink:"/developer-docs/blueprints/export"}},o={},d=[{value:"Types",id:"types",level:2},{value:"Storage - File",id:"storage---file",level:2},{value:"Storage - OCI",id:"storage---oci",level:2},{value:"Storage - Internal",id:"storage---internal",level:2}];function c(e){const i={a:"a",admonition:"admonition",code:"code",h2:"h2",li:"li",p:"p",pre:"pre",ul:"ul",...(0,r.a)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(i.admonition,{type:"info",children:(0,n.jsx)(i.p,{children:"Requires authentik 2022.8"})}),"\n",(0,n.jsx)(i.p,{children:"Blueprints offer a new way to template, automate and distribute authentik configuration. Blueprints can be used to automatically configure instances, manage config as code without any external tools, and to distribute application configs."}),"\n",(0,n.jsx)(i.h2,{id:"types",children:"Types"}),"\n",(0,n.jsxs)(i.p,{children:["Blueprints are yaml files, whose format is described further in ",(0,n.jsx)(i.a,{href:"./v1/structure",children:"File structure"}),". Blueprints can be applied in one of two ways:"]}),"\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsxs)(i.p,{children:["As a Blueprint instance, which is a YAML file mounted into the authentik (worker) container. This file is read and applied regularly (every 60 minutes). Multiple instances can be created for a single blueprint file, and instances can be given context key",":value"," attributes to configure the blueprint."]}),"\n",(0,n.jsx)(i.admonition,{type:"info",children:(0,n.jsx)(i.p,{children:"Starting with authentik 2022.12.1, authentik watches for file modification/creation events in the blueprint directory and will automatically trigger a discovery when a new blueprint file is created, and trigger a blueprint apply when a file is modified."})}),"\n"]}),"\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsx)(i.p,{children:"As a Flow import, which is a YAML file uploaded via the Browser/API. This file is validated and applied directly after being uploaded, but is not further monitored/applied."}),"\n"]}),"\n"]}),"\n",(0,n.jsx)(i.p,{children:"Starting with authentik 2022.8, blueprints are used to manage authentik default flows and other system objects. These blueprints can be disabled/replaced with custom blueprints in certain circumstances."}),"\n",(0,n.jsx)(i.h2,{id:"storage---file",children:"Storage - File"}),"\n",(0,n.jsxs)(i.p,{children:["The authentik container by default looks for blueprints in ",(0,n.jsx)(i.code,{children:"/blueprints"}),". Underneath this directory, there are a couple default subdirectories:"]}),"\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsxs)(i.li,{children:[(0,n.jsx)(i.code,{children:"/blueprints/default"}),": Default blueprints for default flows, tenants, etc"]}),"\n",(0,n.jsxs)(i.li,{children:[(0,n.jsx)(i.code,{children:"/blueprints/example"}),": Example blueprints for common configurations and flows"]}),"\n",(0,n.jsxs)(i.li,{children:[(0,n.jsx)(i.code,{children:"/blueprints/system"}),": System blueprints for authentik managed Property mappings, etc"]}),"\n"]}),"\n",(0,n.jsxs)(i.p,{children:["Any additional ",(0,n.jsx)(i.code,{children:".yaml"})," file in ",(0,n.jsx)(i.code,{children:"/blueprints"})," will be discovered and automatically instantiated, depending on their labels."]}),"\n",(0,n.jsx)(i.p,{children:"To disable existing blueprints, an empty file can be mounted over the existing blueprint."}),"\n",(0,n.jsx)(i.p,{children:"File-based blueprints are automatically removed once they become unavailable, however none of the objects created by those blueprints afre affected by this."}),"\n",(0,n.jsxs)(i.admonition,{type:"info",children:[(0,n.jsx)(i.p,{children:"Please note that, by default, blueprint discovery and evaluation is not guaranteed to follow any specific order."}),(0,n.jsxs)(i.p,{children:["If you have dependencies between blueprints, you should use ",(0,n.jsx)(i.a,{href:"./v1/meta#authentik_blueprintsmetaapplyblueprint",children:"meta models"})," to make sure that objects are created in the correct order."]})]}),"\n",(0,n.jsx)(i.h2,{id:"storage---oci",children:"Storage - OCI"}),"\n",(0,n.jsxs)(i.p,{children:["Blueprints can also be stored in remote ",(0,n.jsx)(i.a,{href:"https://opencontainers.org/",children:"OCI"})," compliant registries. This includes GitHub Container Registry, Docker hub and many other registries."]}),"\n",(0,n.jsxs)(i.p,{children:["To download a blueprint via OCI, set the path to ",(0,n.jsx)(i.code,{children:"oci://ghcr.io/<username>/<package-name>:<ref>"}),". This will fetch the blueprint from an OCI package hosted on GHCR."]}),"\n",(0,n.jsx)(i.p,{children:"To fetch blueprints from a private registry with authentication, credentials can be embedded into the URL."}),"\n",(0,n.jsx)(i.p,{children:"Blueprints are re-fetched each execution, so when using changing tags, blueprints will automatically be updated."}),"\n",(0,n.jsxs)(i.p,{children:["To push a blueprint to an OCI-compatible registry, ",(0,n.jsx)(i.a,{href:"https://oras.land/",children:"ORAS"})," can be used with this command"]}),"\n",(0,n.jsx)(i.pre,{children:(0,n.jsx)(i.code,{children:"oras push ghcr.io/<username>/blueprint/<blueprint name>:latest <yaml file>:application/vnd.goauthentik.blueprint.v1+yaml\n"})}),"\n",(0,n.jsx)(i.h2,{id:"storage---internal",children:"Storage - Internal"}),"\n",(0,n.jsx)(i.admonition,{type:"info",children:(0,n.jsx)(i.p,{children:"Requires authentik 2023.1"})}),"\n",(0,n.jsx)(i.p,{children:"Blueprints can be stored in authentik's database, which allows blueprints to be managed via external configuration management tools like Terraform."}),"\n",(0,n.jsx)(i.p,{children:"Modifying the contents of a blueprint will trigger its reconciliation. Blueprints are validated on submission to prevent invalid blueprints from being saved."})]})}function u(e={}){const{wrapper:i}={...(0,r.a)(),...e.components};return i?(0,n.jsx)(i,{...e,children:(0,n.jsx)(c,{...e})}):c(e)}}}]);